-- searching improvements
vim.keymap.set('n', '/', '/\\v')
vim.keymap.set('n', '?', '?\\v')
vim.keymap.set('n', '*', function()
  vim.api.nvim_exec('/\\v<' .. vim.fn.expand('<cword>') .. '>', false)
end)
vim.keymap.set('n', '#', function()
  vim.api.nvim_exec('?\\v<' .. vim.fn.expand('<cword>') .. '>', false)
end)

vim.keymap.set('n', '<leader>n', '<cmd>nohlsearch<cr>', { desc = 'Clear incremental search highlight' })
vim.keymap.set('n', '<leader>e', '<cmd>e!<cr>', { desc = 'Refresh display of the current buffer' })
vim.keymap.set('n', '<leader>g', "<cmd>grep '\\b<cword>\\b'<cr>", { desc = 'Grep for the word under the cursor' })
vim.keymap.set('n', '<leader>x', '<cmd>!chmod a+x %<cr>', { desc = 'Chmod the current file to world-executable' })

--[[ old mapping, not figuring out how to port right now:
" map \ac (apostrophe comma) to wrap a buffer's lines in single quotes and add
" commas to the ends
nnoremap <leader>ac :<c-u>g/^$/d<cr>:%s/^.*$/'\0',/<cr>:nohlsearch<cr>G$xgg0
]]

-- quickfix list
vim.keymap.set('n', '<leader>qo', '<cmd>copen<cr>', { desc = 'Open Quickfix list' })
vim.keymap.set('n', '<leader>qc', '<cmd>cclose<cr>', { desc = 'Close Quickfix list' })
vim.keymap.set('n', '<leader>qn', '<cmd>cnext<cr>', { desc = 'Next Quickfix list item' })
vim.keymap.set('n', '<leader>qp', '<cmd>cprevious<cr>', { desc = 'Previous Quickfix list item' })

-- location list
vim.keymap.set('n', '<leader>lo', '<cmd>lopen<cr>', { desc = 'Open Location list' })
vim.keymap.set('n', '<leader>lc', '<cmd>lclose<cr>', { desc = 'Close Location list' })
vim.keymap.set('n', '<leader>ln', '<cmd>lnext<cr>', { desc = 'Next Location list item' })
vim.keymap.set('n', '<leader>lp', '<cmd>lprevious<cr>', { desc = 'Previous Location list item' })

-- bash terminals
vim.keymap.set('n', '<leader>bb', '<cmd>e term://bash<cr>', { desc = 'Open a bash shell in current window' })
vim.keymap.set('n', '<leader>bt', '<cmd>tabe term://bash<cr>', { desc = 'Open a bash shell in a new tab' })
vim.keymap.set('n', '<leader>bs', '<cmd>split term://bash<cr>', { desc = 'Open a bash shell in a new horizontal split' })
vim.keymap.set('n', '<leader>bv', '<cmd>vsplit term://bash<cr>', { desc = 'Open a bash shell in a new vertical split' })
vim.keymap.set('t', '<c-w>', '<c-\\><c-n>', { desc = 'Escape to normal mode' })

-- find merge conflicts
vim.keymap.set('n', '<leader>d', '/\\v\\<{7}<cr>', { desc = 'Search for diff markings (<<<<<<<)' })

-- open vim config folder
vim.keymap.set('n', '<leader>c', '<cmd>e ~/.config/nvim/lua<cr><cmd>Lf<cr>', { desc = 'Open the vim lua config folder' })
