return {
  {
    'lewis6991/gitsigns.nvim',
    lazy = false,
    opts = {
      signs = {
        add = { text = '+' },
        change = { text = '~' },
        delete = { text = '_' },
        topdelete = { text = '‾' },
        changedelete = { text = '~' },
      },
    },
    keys = {
      { '<leader>ph', function() require('gitsigns').preview_hunk() end, mode = 'n', desc = 'Preview git hunk' },
      {
        ']h',
        function()
          if vim.wo.diff then
            return ']c'
          end
          vim.schedule(function()
            require('gitsigns').next_hunk()
          end)
          return '<ignore>'
        end,
        mode = 'n',
        desc = 'Jump to next git hunk',
      },
      {
        '[h',
        function()
          if vim.wo.diff then
            return '[c'
          end
          vim.schedule(function()
            require('gitsigns').prev_hunk()
          end)
          return '<ignore>'
        end,
        mode = 'n',
        desc = 'Jump to previous git hunk',
      },
    },
  },
}
