return {
  {
    'nvim-telescope/telescope.nvim',

    dependencies = {
      'nvim-lua/plenary.nvim',
      'nvim-tree/nvim-web-devicons',

      {
        'nvim-telescope/telescope-fzf-native.nvim',
        build = 'make',
      },
    },

    keys = {
      { '<leader>ff', '<cmd>Telescope find_files<cr>', mode = 'n', desc = 'Telescope find_files' },
      { '<leader>fg', '<cmd>Telescope live_grep<cr>',  mode = 'n', desc = 'Telescope live_grep' },
      { '<leader>fb', '<cmd>Telescope buffers<cr>',    mode = 'n', desc = 'Telescope buffers' },
      { '<leader>fh', '<cmd>Telescope help_tags<cr>',  mode = 'n', desc = 'Telescope help_tags' },
      { '<leader>ft', '<cmd>Telescope<cr>',            mode = 'n', desc = 'Telescope' },
    },

    opts = {
      defaults = {
        mappings = {
          i = {
            -- set i_<c-u> back to clearing the line
            ["<c-u>"] = function() vim.cmd([[norm 0lld$A]]) end,

            -- telescope's default i_ mappings are terrible. how do you mess up hjkl?
            ["<c-j>"] = "preview_scrolling_down",
            ["<c-k>"] = "preview_scrolling_up",
            ["<c-h>"] = "preview_scrolling_left",
            ["<c-l>"] = "preview_scrolling_right",
            ["<c-d>"] = false,
            ["<c-f>"] = false,
          },
        },
      },
    },

    config = function(_, opts)
      local tele = require('telescope')
      tele.setup(opts)
      pcall(tele.load_extension, 'fzf')
    end,
  },
}
