return {
  {
    'nvim-treesitter/nvim-treesitter',

    lazy = false,

    opts = {
      highlight = { enable = true },
      incremental_selection = { enable = true },
      indent = { enable = true },
      auto_install = true,
      textobjects = {
        select = {
          enable = true,
          lookahead = true,
          keymaps = {
            ['aa'] = '@parameter.outer',
            ['ia'] = '@parameter.inner',
            ['af'] = '@function.outer',
            ['if'] = '@function.inner',
            ['ac'] = '@class.outer',
            ['ic'] = '@class.inner',
          },
        },
      },
    },

    config = function(_, opts)
      require("nvim-treesitter.configs").setup(opts)
      require("nvim-treesitter.parsers").get_parser_configs().templ = {
        install_info = {
          url = "https://github.com/vrischmann/tree-sitter-templ.git",
          files = { "src/parser.c", "src/scanner.c" },
          branch = "master",
        },
      }
      vim.treesitter.language.register('templ', 'templ')
    end,

    dependencies = {
      'nvim-treesitter/nvim-treesitter-textobjects',
    },

    build = ':TSUpdate',
  },
  {
    'nvim-treesitter/nvim-treesitter-context',
    opts = {
      enable = true,
      max_lines = 0,
      min_window_height = 0,
      multiline_threshold = 20,
      trim_scope = 'inner',
      mode = 'cursor',
      separator = nil,
      on_attach = nil,
    },
  },
  {
    'vrischmann/tree-sitter-templ',
    opts = {},
  }
}
